=== debian/changelog ===
mirall (1.5.0-1) unstable; urgency=low

  * Initial release

 -- Ralf Dragon <dragon@vision.ee.ethz.ch>  Sun, 26 Jan 2014 12:37:03 +0000
