=== debian/control ===
Source: mirall
Section: unknown
Priority: extra
Maintainer: Ralf Dragon <dragon@vision.ee.ethz.ch>
Build-Depends: debhelper (>= 7), cmake, ocsync-dev, libneon27-dev, libneon27, ocsync-dev, ocsync, maemo-optify, libqt4-dev
Standards-Version: 3.8.3
Homepage: http://download.owncloud.com

Package: mirall
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ocsync, libneon27
Description: Owncloud command line client
