=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,3 @@
-#add_subdirectory(integration)
-
 include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
 
 qt_add_resources(MIRALL_RC_SRC ../mirall.qrc)
@@ -13,6 +11,24 @@
 
 set(synclib_NAME ${APPLICATION_EXECUTABLE}sync)
 
+if ( APPLE )
+    list(APPEND OS_SPECIFIC_LINK_LIBRARIES
+         /System/Library/Frameworks/CoreServices.framework
+         /System/Library/Frameworks/Foundation.framework
+         /System/Library/Frameworks/AppKit.framework
+    )
+endif()
+
+IF(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
+    list(APPEND OS_SPECIFIC_LINK_LIBRARIES
+	inotify
+    )
+ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
+
+if(SPARKLE_FOUND)
+    list (APPEND OS_SPECIFIC_LINK_LIBRARIES ${SPARKLE_LIBRARY})
+endif(SPARKLE_FOUND)
+
 set(3rdparty_SRC
 3rdparty/qtsingleapplication/qtsingleapplication.cpp
 3rdparty/qtsingleapplication/qtlocalpeer.cpp
@@ -43,7 +59,6 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/qtsingleapplication
     ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/QProgressIndicator
     ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/fancylineedit
-    ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/csync
     ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/qjson
     )
 
@@ -57,7 +72,6 @@
     mirall/owncloudpropagator.cpp
     mirall/syncjournalfilerecord.cpp
     mirall/syncjournaldb.cpp
-    mirall/fileutils.cpp
     mirall/theme.cpp
     mirall/owncloudtheme.cpp
     mirall/logger.cpp
@@ -68,7 +82,9 @@
     mirall/networkjobs.cpp
     mirall/account.cpp
     mirall/quotainfo.cpp
+    mirall/clientproxy.cpp
     creds/dummycredentials.cpp
+    creds/abstractcredentials.cpp
     creds/httpcredentials.cpp
     creds/credentialsfactory.cpp
     creds/http/httpconfigfile.cpp
@@ -88,6 +104,7 @@
     mirall/folderwatcher.h
     mirall/csyncthread.h
     mirall/owncloudpropagator.h
+    mirall/owncloudpropagator_p.h
     mirall/syncjournaldb.h
     mirall/theme.h
     mirall/owncloudtheme.h
@@ -98,6 +115,7 @@
     mirall/networkjobs.h
     mirall/account.h
     mirall/quotainfo.h
+    mirall/clientproxy.h
     creds/abstractcredentials.h
     creds/dummycredentials.h
     creds/httpcredentials.h
@@ -113,20 +131,17 @@
     3rdparty/qjson/json.h
 )
 
-IF( INOTIFY_FOUND )
-    set(libsync_SRCS ${libsync_SRCS} mirall/inotify.cpp)
-    set(libsync_SRCS ${libsync_SRCS} mirall/folderwatcher_inotify.cpp)
-    set(libsync_HEADERS ${libsync_HEADERS} mirall/inotify.h)
-    set(libsync_HEADERS ${libsync_HEADERS} mirall/folderwatcher_inotify.h)
+IF( NOT WIN32 AND NOT APPLE )
+    set(libsync_SRCS ${libsync_SRCS} mirall/folderwatcher_linux.cpp)
+    set(libsync_HEADERS ${libsync_HEADERS} mirall/folderwatcher_linux.h)
 ENDIF()
 IF( WIN32 )
     set(libsync_SRCS ${libsync_SRCS} mirall/folderwatcher_win.cpp)
     set(libsync_HEADERS ${libsync_HEADERS} mirall/folderwatcher_win.h)
 ENDIF()
 IF( APPLE )
-    set(libsync_SRCS ${libsync_SRCS} mirall/folderwatcher_mac.cpp)
+    list(APPEND libsync_SRCS mirall/folderwatcher_mac.cpp)
 ENDIF()
-
 
 qt_wrap_cpp(syncMoc ${libsync_HEADERS})
 
@@ -161,24 +176,12 @@
     )
 ENDIF(NOT APPLE)
 
-IF( DEFINED CSYNC_BUILD_PATH )
-SET(HTTPBF_LIBRARY ${CSYNC_BUILD_PATH}/src/httpbf/libhttpbf.a)
-ELSE()
-FIND_LIBRARY(HTTPBF_LIBRARY NAMES httpbf HINTS $ENV{CSYNC_DIR})
-ENDIF()
-
-
 list(APPEND libsync_LINK_TARGETS
     ${QT_LIBRARIES}
-    ${CSYNC_LIBRARY}
-    ${HTTPBF_LIBRARY}
-)
-
-IF(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
-   list(APPEND libsync_LINK_TARGETS
-      inotify
-   )
-ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
+    ocsync
+    httpbf
+    ${OS_SPECIFIC_LINK_LIBRARIES}
+)
 
 if(QTKEYCHAIN_FOUND)
     list(APPEND libsync_LINK_TARGETS ${QTKEYCHAIN_LIBRARY})
@@ -207,10 +210,6 @@
 )
 
 target_link_libraries(${synclib_NAME} ${libsync_LINK_TARGETS} )
-
-if ( APPLE )
-    target_link_libraries(${synclib_NAME} /System/Library/Frameworks/CoreServices.framework)
-endif()
 
 if(NOT BUILD_OWNCLOUD_OSX_BUNDLE)
     install(TARGETS ${synclib_NAME}
@@ -225,6 +224,11 @@
     endif()
 else()
     install(TARGETS ${synclib_NAME} DESTINATION ${OWNCLOUD_OSX_BUNDLE}/Contents/MacOS)
+    if (SPARKLE_FOUND)
+        install(DIRECTORY "${SPARKLE_LIBRARY}"
+	        DESTINATION "${OWNCLOUD_OSX_BUNDLE}/Contents/Frameworks")
+    endif (SPARKLE_FOUND)
+
 endif()
 
 set(mirall_UI
@@ -254,13 +258,12 @@
     wizard/owncloudwizard.cpp
     wizard/owncloudsetuppage.cpp
     wizard/owncloudhttpcredspage.cpp
+    wizard/abstractcredswizardpage.cpp
     wizard/owncloudwizardresultpage.cpp
     wizard/owncloudwizardcommon.cpp
     wizard/owncloudshibbolethcredspage.cpp
     wizard/owncloudadvancedsetuppage.cpp
     mirall/owncloudsetupwizard.cpp
-    mirall/updatedetector.cpp
-    mirall/occinfo.cpp
     mirall/sslerrordialog.cpp
     mirall/logbrowser.cpp
     mirall/settingsdialog.cpp
@@ -270,6 +273,7 @@
     mirall/ignorelisteditor.cpp
     mirall/owncloudgui.cpp
     mirall/socketapi.cpp
+    mirall/sslbutton.cpp
 )
 
 set(mirall_HEADERS
@@ -280,12 +284,12 @@
     wizard/owncloudwizard.h
     wizard/owncloudsetuppage.h
     wizard/owncloudhttpcredspage.h
+    wizard/abstractcredswizardpage.h
     wizard/owncloudwizardresultpage.h
     wizard/owncloudwizardcommon.h
     wizard/owncloudshibbolethcredspage.h
     wizard/owncloudadvancedsetuppage.h
     mirall/folderstatusmodel.h
-    mirall/updatedetector.h
     mirall/sslerrordialog.h
     mirall/logbrowser.h
     mirall/settingsdialog.h
@@ -296,18 +300,37 @@
     mirall/protocolwidget.h
     mirall/owncloudgui.h
     mirall/socketapi.h
-)
-
-if( UNIX AND NOT APPLE)
-    if(NOT DEFINED USE_INOTIFY)
-        set(USE_INOTIFY ON)
-    endif()
-endif()
+    mirall/sslbutton.h
+)
+
+set(updater_SRCS
+    updater/updateinfo.cpp
+    updater/updater.cpp
+    updater/ocupdater.cpp
+)
+
+set(updater_HEADERS
+    updater/updater.h
+    updater/ocupdater.h
+)
+
+IF( APPLE )
+    list(APPEND mirall_SRCS mirall/cocoainitializer_mac.mm)
+    list(APPEND mirall_HEADERS mirall/cocoainitializer.h)
+
+    if(SPARKLE_FOUND)
+       # Define this, we need to check in updater.cpp
+       add_definitions( -DHAVE_SPARKLE )
+       list(APPEND updater_SRCS updater/sparkleupdater_mac.mm)
+       list(APPEND updater_HEADERS updater/sparkleupdater.h)
+   endif()
+ENDIF()
 
 # csync is required.
-include_directories(${CSYNC_INCLUDE_DIR}/csync ${CSYNC_INCLUDE_DIR} ${CSYNC_INCLUDE_DIR}/httpbf/src ${CSYNC_BUILD_PATH}/src)
+include_directories(../csync/src ../csync/src/httpbf/src ${CMAKE_CURRENT_BINARY_DIR}/../csync ${CMAKE_CURRENT_BINARY_DIR}/../csync/src )
 include_directories(${3rdparty_INC})
 
+qt_wrap_cpp(updaterMoc ${updater_HEADERS})
 qt_wrap_cpp(mirallMoc ${mirall_HEADERS})
 
 qt_add_translation(mirall_I18N ${TRANSLATIONS})
@@ -376,19 +399,3 @@
 
     set (QM_DIR ${OWNCLOUD_OSX_BUNDLE}/Contents/Resources/Translations)
     install(FILES ${mirall_I18N} DESTINATION ${QM_DIR})
-    file(GLOB qt_I18N ${QT_TRANSLATIONS_DIR}/qt_??.qm ${QT_TRANSLATIONS_DIR}/qt_??_??.qm)
-    install(FILES ${qt_I18N} DESTINATION ${QM_DIR})
-    file(GLOB qtkeychain_I18N ${QT_TRANSLATIONS_DIR}/qtkeychain*.qm)
-    install(FILES ${qtkeychain_I18N} DESTINATION ${QM_DIR})
-endif()
-
-
-set_target_properties( ${APPLICATION_EXECUTABLE} PROPERTIES
-        RUNTIME_OUTPUT_DIRECTORY  ${BIN_OUTPUT_DIRECTORY}
-)
-target_link_libraries( ${APPLICATION_EXECUTABLE} ${QT_LIBRARIES} )
-target_link_libraries( ${APPLICATION_EXECUTABLE} ${synclib_NAME} )
-target_link_libraries( ${APPLICATION_EXECUTABLE} ${CSYNC_LIBRARY} )
-
-install(TARGETS ${APPLICATION_EXECUTABLE}
-        RUNTIME DESTINATION bin
