=== debian/changelog ===
mirall (1.5.2-2) lucid; urgency=low

  * Disable pedantic compiling

 -- Ralf Dragon <dragon@vision.ee.ethz.ch>  Sun, 09 Mar 2014 10:22:47 +0000

mirall (1.5.2-1) lucid; urgency=low

  * Port upstream version 1.5.2
  * ocsync is included now, so this package will conflict if ocsync is installed
  * Patch for FAT file systems

 -- Ralf Dragon <dragon@vision.ee.ethz.ch>  Sun, 09 Mar 2014 09:53:54 +0000
