=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,6 @@
+#set(CMAKE_AUTOMOC TRUE)
+#include(GenerateExportHeader)
+
 include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
 
 qt_add_resources(MIRALL_RC_SRC ../mirall.qrc)
@@ -25,9 +28,9 @@
     )
 ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
 
-if(SPARKLE_FOUND)
+if(SPARKLE_FOUND AND NOT BUILD_LIBRARIES_ONLY)
     list (APPEND OS_SPECIFIC_LINK_LIBRARIES ${SPARKLE_LIBRARY})
-endif(SPARKLE_FOUND)
+endif()
 
 set(3rdparty_SRC
 3rdparty/qtsingleapplication/qtsingleapplication.cpp
@@ -38,6 +41,13 @@
 3rdparty/QProgressIndicator/QProgressIndicator.cpp
 )
 
+if (APPLE)
+        list(APPEND 3rdparty_SRC
+        3rdparty/qtmacgoodies/src/macpreferenceswindow.mm
+        3rdparty/qtmacgoodies/src/macstandardicon.mm
+        )
+endif()
+
 set(3rdparty_HEADER
 3rdparty/qtsingleapplication/qtlocalpeer.h
 3rdparty/qtsingleapplication/qtsingleapplication.h
@@ -46,7 +56,15 @@
 3rdparty/QProgressIndicator/QProgressIndicator.h
 )
 
+if (APPLE)
+        list(APPEND 3rdparty_HEADER
+        3rdparty/qtmacgoodies/src/macpreferenceswindow.h
+        3rdparty/qtmacgoodies/src/macstandardicon.h
+        )
+endif()
+
 qt_wrap_cpp(3rdparty_MOC ${3rdparty_HEADER})
+
 
 if(NOT WIN32)
 	list(APPEND 3rdparty_SRC 3rdparty/qtlockedfile/qtlockedfile_unix.cpp)
@@ -60,6 +78,7 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/QProgressIndicator
     ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/fancylineedit
     ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/qjson
+    ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/qtmacgoodies/src
     )
 
 set(libsync_SRCS
@@ -68,14 +87,18 @@
     mirall/folderwatcher.cpp
     mirall/syncresult.cpp
     mirall/mirallconfigfile.cpp
-    mirall/csyncthread.cpp
+    mirall/syncengine.cpp
     mirall/owncloudpropagator.cpp
+    mirall/propagatorjobs.cpp
+    mirall/propagator_qnam.cpp
+    mirall/propagator_legacy.cpp
     mirall/syncjournalfilerecord.cpp
     mirall/syncjournaldb.cpp
     mirall/theme.cpp
     mirall/owncloudtheme.cpp
     mirall/logger.cpp
     mirall/utility.cpp
+    mirall/filesystem.cpp
     mirall/connectionvalidator.cpp
     mirall/progressdispatcher.cpp
     mirall/mirallaccessmanager.cpp
@@ -83,72 +106,52 @@
     mirall/account.cpp
     mirall/quotainfo.cpp
     mirall/clientproxy.cpp
+    mirall/syncrunfilelog.cpp
+    mirall/cookiejar.cpp
     creds/dummycredentials.cpp
     creds/abstractcredentials.cpp
-    creds/httpcredentials.cpp
     creds/credentialsfactory.cpp
     creds/http/httpconfigfile.cpp
-    creds/shibbolethcredentials.cpp
-    creds/shibboleth/shibbolethaccessmanager.cpp
-    creds/shibboleth/shibbolethcookiejar.cpp
-    creds/shibboleth/shibbolethwebview.cpp
-    creds/shibboleth/shibbolethrefresher.cpp
-    creds/shibboleth/shibbolethconfigfile.cpp
     creds/credentialscommon.cpp
     3rdparty/qjson/json.cpp
 )
-
-set(libsync_HEADERS
-    mirall/folderman.h
-    mirall/folder.h
-    mirall/folderwatcher.h
-    mirall/csyncthread.h
-    mirall/owncloudpropagator.h
-    mirall/owncloudpropagator_p.h
-    mirall/syncjournaldb.h
-    mirall/theme.h
-    mirall/owncloudtheme.h
-    mirall/logger.h
-    mirall/connectionvalidator.h
-    mirall/progressdispatcher.h
-    mirall/mirallaccessmanager.h
-    mirall/networkjobs.h
-    mirall/account.h
-    mirall/quotainfo.h
-    mirall/clientproxy.h
-    creds/abstractcredentials.h
-    creds/dummycredentials.h
-    creds/httpcredentials.h
-    creds/credentialsfactory.h
-    creds/http/httpconfigfile.h
-    creds/shibbolethcredentials.h
-    creds/shibboleth/shibbolethaccessmanager.h
-    creds/shibboleth/shibbolethcookiejar.h
-    creds/shibboleth/shibbolethwebview.h
-    creds/shibboleth/shibbolethrefresher.h
-    creds/shibboleth/shibbolethconfigfile.h
-    creds/credentialscommon.h
-    3rdparty/qjson/json.h
-)
+if(TOKEN_AUTH_ONLY)
+	set (libsync_SRCS
+		${libsync_SRCS}
+		creds/tokencredentials.cpp
+	)
+else()
+    set (libsync_SRCS
+        ${libsync_SRCS}
+        creds/httpcredentials.cpp
+        creds/shibbolethcredentials.cpp
+        creds/shibboleth/shibbolethwebview.cpp
+        creds/shibboleth/shibbolethrefresher.cpp
+        creds/shibboleth/authenticationdialog.cpp
+        creds/shibboleth/shibbolethuserjob.cpp
+    )
+endif()
 
 IF( NOT WIN32 AND NOT APPLE )
     set(libsync_SRCS ${libsync_SRCS} mirall/folderwatcher_linux.cpp)
-    set(libsync_HEADERS ${libsync_HEADERS} mirall/folderwatcher_linux.h)
 ENDIF()
 IF( WIN32 )
     set(libsync_SRCS ${libsync_SRCS} mirall/folderwatcher_win.cpp)
-    set(libsync_HEADERS ${libsync_HEADERS} mirall/folderwatcher_win.h)
 ENDIF()
 IF( APPLE )
     list(APPEND libsync_SRCS mirall/folderwatcher_mac.cpp)
 ENDIF()
 
+foreach(s ${libsync_SRCS})
+  string(REPLACE .cpp .h t ${s})
+  list(APPEND libsync_HEADERS ${t})
+endforeach()
 qt_wrap_cpp(syncMoc ${libsync_HEADERS})
 
 # These headers are installed for libowncloudsync to be used by 3rd party apps
 set(owncloudsync_HEADERS
     mirall/account.h
-    mirall/csyncthread.h
+    mirall/syncengine.h
     mirall/folder.h
     mirall/folderman.h
     mirall/folderwatcher.h
@@ -160,6 +163,7 @@
     mirall/syncresult.h
 )
 
+
 set(creds_HEADERS
     creds/abstractcredentials.h
     creds/httpcredentials.h
@@ -168,11 +172,11 @@
 IF (NOT APPLE)
     INSTALL(
         FILES ${owncloudsync_HEADERS}
-        DESTINATION ${INCLUDE_INSTALL_DIR}/owncloudsync/mirall
+	DESTINATION ${INCLUDE_INSTALL_DIR}/${synclib_NAME}/mirall
     )
     INSTALL(
         FILES ${creds_HEADERS}
-        DESTINATION ${INCLUDE_INSTALL_DIR}/owncloudsync/creds
+	DESTINATION ${INCLUDE_INSTALL_DIR}/${synclib_NAME}/creds
     )
 ENDIF(NOT APPLE)
 
@@ -183,7 +187,7 @@
     ${OS_SPECIFIC_LINK_LIBRARIES}
 )
 
-if(QTKEYCHAIN_FOUND)
+if(QTKEYCHAIN_FOUND OR QT5KEYCHAIN_FOUND)
     list(APPEND libsync_LINK_TARGETS ${QTKEYCHAIN_LIBRARY})
     include_directories(${QTKEYCHAIN_INCLUDE_DIR})
     # tmp fix until this is fixed in qtkeychain
@@ -200,16 +204,45 @@
 
 endif()
 
+# syncMoc is empty?
+message("SyncMoc: ${syncMoc}")
 add_library(${synclib_NAME} SHARED ${libsync_SRCS} ${syncMoc})
-
-qt5_use_modules(${synclib_NAME} Widgets Network Xml WebKitWidgets Sql)
+#GENERATE_EXPORT_HEADER( ${synclib_NAME}
+#	BASE_NAME ${synclib_NAME}
+#	EXPORT_MACRO_NAME OWNCLOUDSYNC_EXPORT
+ #       EXPORT_FILE_NAME owncloudlib.h
+#	STATIC_DEFINE OWNCLOUD_BUILT_AS_STATIC
+#)
+
+
+if(TOKEN_AUTH_ONLY)
+    qt5_use_modules(${synclib_NAME} Network Xml Sql)
+else()
+    qt5_use_modules(${synclib_NAME} Widgets Network Xml WebKitWidgets Sql)
+endif()
 
 set_target_properties( ${synclib_NAME}  PROPERTIES
 	VERSION ${MIRALL_VERSION}
 	SOVERSION ${MIRALL_SOVERSION}
 )
+set_target_properties( ${synclib_NAME} PROPERTIES
+	INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}/${APPLICATION_EXECUTABLE}" )
 
 target_link_libraries(${synclib_NAME} ${libsync_LINK_TARGETS} )
+
+if(BUILD_LIBRARIES_ONLY)
+    #add_library(${synclib_NAME}_static STATIC ${libsync_SRCS} ${syncMoc})
+    #qt5_use_modules(${synclib_NAME}_static Widgets Network Xml Sql)
+
+    #set_target_properties( ${synclib_NAME}_static  PROPERTIES
+    #    VERSION ${MIRALL_VERSION}
+    #    SOVERSION ${MIRALL_SOVERSION}
+    #)
+
+    #target_link_libraries(${synclib_NAME}_static ${libsync_LINK_TARGETS} )
+endif()
+
+
 
 if(NOT BUILD_OWNCLOUD_OSX_BUNDLE)
     install(TARGETS ${synclib_NAME}
@@ -276,6 +309,8 @@
     mirall/sslbutton.cpp
 )
 
+
+
 set(mirall_HEADERS
     mirall/application.h
     mirall/systray.h
@@ -318,6 +353,9 @@
     list(APPEND mirall_SRCS mirall/cocoainitializer_mac.mm)
     list(APPEND mirall_HEADERS mirall/cocoainitializer.h)
 
+    list(APPEND mirall_SRCS mirall/settingsdialogmac.cpp)
+    list(APPEND mirall_HEADERS mirall/settingsdialogmac.h)
+
     if(SPARKLE_FOUND)
        # Define this, we need to check in updater.cpp
        add_definitions( -DHAVE_SPARKLE )
@@ -367,35 +405,17 @@
     set(ADDITIONAL_APP_MODULES DBus)
 endif(WITH_DBUS)
 
-if(NOT BUILD_OWNCLOUD_OSX_BUNDLE)
+if(NOT BUILD_OWNCLOUD_OSX_BUNDLE AND NOT BUILD_LIBRARIES_ONLY)
     set(BIN_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
 
-if(NOT WIN32)
-	file( GLOB _icons "${theme_dir}/colored/${ICON_APP_NAME}-icon-*.png" )
-    foreach( _file ${_icons} )
-	    string( REPLACE "${theme_dir}/colored/${ICON_APP_NAME}-icon-" "" _res ${_file} )
-        string( REPLACE ".png" "" _res ${_res} )
-	install( FILES ${_file} RENAME ${ICON_APP_NAME}.png DESTINATION ${DATADIR}/icons/hicolor/${_res}x${_res}/apps )
-    endforeach( _file )
-endif(NOT WIN32)
+    if(NOT WIN32)
+        file( GLOB _icons "${theme_dir}/colored/${ICON_APP_NAME}-icon-*.png" )
+        foreach( _file ${_icons} )
+            string( REPLACE "${theme_dir}/colored/${ICON_APP_NAME}-icon-" "" _res ${_file} )
+            string( REPLACE ".png" "" _res ${_res} )
+        install( FILES ${_file} RENAME ${ICON_APP_NAME}.png DESTINATION ${DATADIR}/icons/hicolor/${_res}x${_res}/apps )
+        endforeach( _file )
+    endif(NOT WIN32)
 
     install(FILES ${mirall_I18N} DESTINATION share/${APPLICATION_EXECUTABLE}/i18n)
 
-    # we may not add MACOSX_BUNDLE here, if not building one
-
-    # add_executable( ${APPLICATION_EXECUTABLE} main.cpp ${final_src})
-    add_executable( ${APPLICATION_EXECUTABLE} WIN32 main.cpp ${final_src})
-    qt5_use_modules(${APPLICATION_EXECUTABLE} Widgets Network Xml WebKitWidgets Sql ${ADDITIONAL_APP_MODULES})
-else()
-    set(BIN_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")
-    include(DeployQt4)
-
-    set(CMAKE_INSTALL_PREFIX ".") # Examples use /Applications. hurmpf.
-    set(MACOSX_BUNDLE_ICON_FILE "ownCloud.icns")
-
-    # we must add MACOSX_BUNDLE only if building a bundle
-    add_executable( ${APPLICATION_EXECUTABLE} WIN32 MACOSX_BUNDLE main.cpp ${final_src})
-    qt5_use_modules(${APPLICATION_EXECUTABLE} Widgets Network Xml WebKitWidgets Sql  ${ADDITIONAL_APP_MODULES})
-
-    set (QM_DIR ${OWNCLOUD_OSX_BUNDLE}/Contents/Resources/Translations)
-    install(FILES ${mirall_I18N} DESTINATION ${QM_DIR})
