=== debian/changelog ===
mirall (1.6.1) lucid; urgency=low

  * port new upstream version

 -- Ralf Dragon <dragon@vision.ee.ethz.ch>  Wed, 16 Jul 2014 20:57:26 +0100
