## mirall 1.6.3

=== debian/changelog ===
mirall (1.6.3) lucid; urgency=low

  * port new upstream version

 -- Ralf Dragon <dragon@vision.ee.ethz.ch>  Wed, 19 Sep 2014 23:18:26 +0100

mirall (1.6.2) lucid; urgency=low

  * port new upstream version

 -- Ralf Dragon <dragon@vision.ee.ethz.ch>  Wed, 22 Aug 2014 23:18:26 +0100
